From 93cf1f027c8183892c48c63f2c70cebe39486184 Mon Sep 17 00:00:00 2001
From: Jeffy Chen <jeffy.chen@rock-chips.com>
Date: Mon, 19 Apr 2021 09:40:10 +0800
Subject: [PATCH 47/98] HACK: gl-renderer: Fix random hang during hotplug

Try to bind to a valid output before attaching buffers for mali.

Signed-off-by: Jeffy Chen <jeffy.chen@rock-chips.com>
---
 libweston/renderer-gl/gl-renderer.c | 4 ++++
 1 file changed, 4 insertions(+)

diff --git a/libweston/renderer-gl/gl-renderer.c b/libweston/renderer-gl/gl-renderer.c
index ccb6e7c..1be9eb4 100644
--- a/libweston/renderer-gl/gl-renderer.c
+++ b/libweston/renderer-gl/gl-renderer.c
@@ -2159,6 +2159,10 @@ gl_renderer_flush_damage(struct weston_surface *surface,
 	if (!texture_used)
 		return;
 
+	/* HACK: Mali needs a valid context for uploading */
+	if (gr->is_mali_egl && output)
+		use_output(output);
+
 	if (!pixman_region32_not_empty(&gb->texture_damage) &&
 	    !gb->needs_full_upload)
 		goto done;
-- 
2.20.1

